## spirv-llvm-translator-22 22.~~+git20260218

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.4)

if(NOT DEFINED BASE_LLVM_VERSION)
  set (BASE_LLVM_VERSION 22.1.0)
endif(NOT DEFINED BASE_LLVM_VERSION)
set(LLVM_SPIRV_VERSION ${BASE_LLVM_VERSION}.0)

include(FetchContent)
include(FindPkgConfig)

option(LLVM_SPIRV_INCLUDE_TESTS
  "Generate build targets for the llvm-spirv lit tests."
  ${LLVM_INCLUDE_TESTS})

if (NOT DEFINED LLVM_SPIRV_BUILD_EXTERNAL)
  # check if we build inside llvm or not
  if(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
    set(LLVM_SPIRV_BUILD_EXTERNAL YES)
  endif(CMAKE_SOURCE_DIR STREQUAL CMAKE_CURRENT_SOURCE_DIR)
endif (NOT DEFINED LLVM_SPIRV_BUILD_EXTERNAL)

if(LLVM_SPIRV_BUILD_EXTERNAL)
  # Make sure llvm-spirv gets built when building outside the llvm tree.
  set(LLVM_BUILD_TOOLS ON)
endif(LLVM_SPIRV_BUILD_EXTERNAL)

# Download spirv.hpp from the official SPIRV-Headers repository.
# One can skip this step by manually setting
# LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR path.
if(NOT DEFINED LLVM_TOOL_SPIRV_HEADERS_BUILD AND
   NOT DEFINED LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR)
  set(LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR
    "${CMAKE_CURRENT_BINARY_DIR}/SPIRV-Headers")
  message(STATUS "SPIR-V Headers location is not specified. Will try to download
          spirv.hpp from https://github.com/KhronosGroup/SPIRV-Headers into
          ${LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR}")
  file(READ spirv-headers-tag.conf SPIRV_HEADERS_TAG)
  # Strip the potential trailing newline from tag
  string(STRIP "${SPIRV_HEADERS_TAG}" SPIRV_HEADERS_TAG)
  FetchContent_Declare(spirv-headers
    GIT_REPOSITORY    https://github.com/KhronosGroup/SPIRV-Headers.git
    GIT_TAG           ${SPIRV_HEADERS_TAG}
    SOURCE_DIR ${LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR}
  )
  FetchContent_MakeAvailable(spirv-headers)
else()
  if(NOT DEFINED LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR)
    # This means LLVM_TOOL_SPIRV_HEADERS_BUILD is defined, therefore
    # SPIRV-Headers exist as a subproject.
    set(LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR
      "${CMAKE_SOURCE_DIR}/projects/SPIRV-Headers")
    if(NOT EXISTS ${LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR})
      message(FATAL_ERROR "No location specified for SPIRV-Headers.
              Try setting the LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR
              path or put the project into the llvm/projects folder
              under the name 'SPIRV-Headers'")
    endif()
  endif()
  message(STATUS "Using SPIR-V Headers from
          ${LLVM_EXTERNAL_SPIRV_HEADERS_SOURCE_DIR}")
endif()

if(LLVM_SPIRV_BUILD_EXTERNAL)
  project(LLVM_SPIRV
    VERSION
      ${LLVM_SPIRV_VERSION}
    LANGUAGES
      CXX
      C
  )

  set(CMAKE_CXX_STANDARD 17)
  set(CMAKE_CXX_STANDARD_REQUIRED ON)

  if(LLVM_SPIRV_INCLUDE_TESTS)
    set(LLVM_TEST_COMPONENTS
      llvm-as
      llvm-dis
    )
  endif(LLVM_SPIRV_INCLUDE_TESTS)

  find_package(LLVM ${BASE_LLVM_VERSION} REQUIRED
    COMPONENTS
      Analysis
      BitReader
      BitWriter
      CodeGen
      Core
      Passes
      Support
      TargetParser
      TransformUtils
      ${LLVM_TEST_COMPONENTS}
  )
  set(CMAKE_MODULE_PATH
    ${CMAKE_MODULE_PATH}
    ${LLVM_CMAKE_DIR}
  )
  include(AddLLVM)
  include(HandleLLVMOptions)
  include(LLVM-Config)

  message(STATUS "Found LLVM: ${LLVM_VERSION}")

  option(CCACHE_ALLOWED "allow use of ccache" TRUE)
  find_program(CCACHE_EXE_FOUND ccache)
  if(CCACHE_EXE_FOUND AND CCACHE_ALLOWED)
    message(STATUS "Found ccache: ${CCACHE_EXE_FOUND}")
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
  endif()
endif()

is_llvm_target_library("SPIRV" spirv_present_result INCLUDED_TARGETS)
if(spirv_present_result)
  message(STATUS "Found SPIR-V Backend")
  set(SPIRV_BACKEND_FOUND TRUE)
  add_compile_definitions(LLVM_SPIRV_BACKEND_TARGET_PRESENT)
endif()

set(LLVM_SPIRV_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/include)

# first try locating SPIRV-Tools via pkgconfig (the old way)
pkg_search_module(SPIRV_TOOLS SPIRV-Tools)
if (NOT SPIRV_TOOLS_FOUND)
  # then try locating SPIRV-Tools via cmake (the new way)
  find_package(SPIRV-Tools)
  find_package(SPIRV-Tools-tools)
  if (SPIRV-Tools_FOUND AND SPIRV-Tools-tools_FOUND)
    set(SPIRV_TOOLS_FOUND TRUE)
    # check for the existance of library targets in the found packages
    if(TARGET SPIRV-Tools-shared)
      # use the shared libary target if present
      set(SPIRV-Tools-library SPIRV-Tools-shared)
    elseif(TARGET SPIRV-Tools-static)
      # otherwise fallback to the static library target
      set(SPIRV-Tools-library SPIRV-Tools-static)
    else()
      message(FATAL_ERROR "Found SPIRV-Tools package but neither "
              "SPIRV-Tools-shared or SPIRV-Tools-static targets exist.")
    endif()
    set(SPIRV_TOOLS_LDFLAGS ${SPIRV-Tools-library})
    get_target_property(SPIRV_TOOLS_INCLUDE_DIRS ${SPIRV-Tools-library} INTERFACE_INCLUDE_DIRECTORIES)
  endif()
endif()

option(LLVM_SPIRV_ENABLE_LIBSPIRV_DIS "Enable --spirv-tools-dis support.")

if (NOT SPIRV_TOOLS_FOUND AND LLVM_SPIRV_ENABLE_LIBSPIRV_DIS)
  message(STATUS "SPIRV-Tools not found; project will be built without "
          "--spirv-tools-dis support.")
endif()


add_subdirectory(lib/SPIRV)
add_subdirectory(tools/llvm-spirv)
if(LLVM_SPIRV_INCLUDE_TESTS)
  add_subdirectory(test)
endif(LLVM_SPIRV_INCLUDE_TESTS)

install(
  FILES
    ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVLib.h
    ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVOpts.h
    ${LLVM_SPIRV_INCLUDE_DIRS}/LLVMSPIRVExtensions.inc
  DESTINATION
    ${CMAKE_INSTALL_PREFIX}/include/LLVMSPIRVLib
)

configure_file(LLVMSPIRVLib.pc.in ${CMAKE_BINARY_DIR}/LLVMSPIRVLib.pc @ONLY)
install(
  FILES
    ${CMAKE_BINARY_DIR}/LLVMSPIRVLib.pc
  DESTINATION
    ${CMAKE_INSTALL_PREFIX}/lib${LLVM_LIBDIR_SUFFIX}/pkgconfig
)

=== debian/changelog ===
spirv-llvm-translator-22 (22.~~+git20260218-1) unstable; urgency=medium

  * New upstream snapshot.
  * Fork source package as spirv-llvm-translator-22.
  * Rename binary packages: *21* => *22*.
  * Build with llvm 22.
  * Update visibility-hidden.patch.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 26 Feb 2026 03:46:10 +0100

spirv-llvm-translator-21 (21.1.4-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-20 20.1.10-1.
  * Cherry-pick cooperative_matrix_constant_null test fix from upstream
    PR 3568 to fix FTBFS with spirv-tools 2026.1.  (Closes: #1127539)
  * Restrict watch file to 21.* releases.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 13 Feb 2026 23:28:47 +0100

spirv-llvm-translator-21 (21.1.3-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-20 20.1.9-1.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 28 Dec 2025 02:00:07 +0100

spirv-llvm-translator-21 (21.1.2-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-20 20.1.8-1.
  * Update B-D after the spirv-tools split.
  * Cherry-pick upstream fix for newer spirv-tools.  (Closes: #1121533)

 -- Andreas Beckmann <anbe@debian.org>  Sat, 13 Dec 2025 22:32:05 +0100

spirv-llvm-translator-21 (21.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Update .symbols control file.
  * Merge changes from spirv-llvm-translator-20 20.1.7-1.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 13 Oct 2025 00:32:03 +0200

spirv-llvm-translator-21 (21.1.0-3) unstable; urgency=medium

  * Merge changes from spirv-llvm-translator-20 20.1.6-1.
  * Update .symbols control file for gcc-15 builds.
  * Mark symbols disappearing with LTO.  (Closes: #1116519)

 -- Andreas Beckmann <anbe@debian.org>  Mon, 29 Sep 2025 11:13:05 +0200

spirv-llvm-translator-21 (21.1.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 25 Sep 2025 09:04:36 +0300

spirv-llvm-translator-21 (21.1.0-1) experimental; urgency=medium

  * New upstream release.
  * Fork source package as spirv-llvm-translator-21.
  * Rename binary packages: *20* => *21*.
  * Build with llvm 21.
  * Bump spirv-headers dependency to 1.6.1+1.4.321.0-2.
  * Update visibility-hidden.patch.
  * Update .symbols control file.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 27 Aug 2025 09:39:59 +0200

spirv-llvm-translator-20 (20.1.10-1) experimental; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-19 19.1.15-1.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 12 Feb 2026 20:11:59 +0100

spirv-llvm-translator-20 (20.1.9-1) experimental; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-19 19.1.14-1.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 23 Dec 2025 22:11:00 +0100

spirv-llvm-translator-20 (20.1.8-1) experimental; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-19 19.1.13-1.
  * Update B-D after the spirv-tools split.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 26 Nov 2025 23:43:39 +0100

spirv-llvm-translator-20 (20.1.7-1) experimental; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-19 19.1.12-1.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 12 Oct 2025 15:19:10 +0200

spirv-llvm-translator-20 (20.1.6-1) experimental; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-19 19.1.11-1.
  * Bump spirv-headers dependency to 1.6.1+1.4.321.0-2.
  * Update .symbols control file.
  * Update .symbols control file for gcc-15 builds.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 12 Sep 2025 03:04:38 +0200

spirv-llvm-translator-20 (20.1.5-1) experimental; urgency=medium

  * New upstream release.
  * Restrict watch file to 20.* releases.
  * Merge changes from spirv-llvm-translator-19 19.1.10-1.
  * Bump spirv-headers dependency to 1.6.1+1.4.313.0.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 14 Aug 2025 23:08:05 +0200

spirv-llvm-translator-20 (20.1.1-1) experimental; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-19 19.1.6-1.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 09 Apr 2025 21:47:14 +0200

spirv-llvm-translator-20 (20.1.0-1) experimental; urgency=medium

  * New upstream release.
  * Fork source package as spirv-llvm-translator-20.
  * Rename binary packages: *19* => *20*.
  * Build with llvm 20.
  * Update visibility-hidden.patch.
  * Update .symbols control file.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 24 Mar 2025 19:27:29 +0100

spirv-llvm-translator-19 (19.1.15-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-18 18.1.20-1.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 11 Feb 2026 20:27:04 +0100

spirv-llvm-translator-19 (19.1.14-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-18 18.1.19-1.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 22 Dec 2025 09:40:00 +0100

spirv-llvm-translator-19 (19.1.13-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-18 18.1.18-1.
  * Update B-D after the spirv-tools split.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 25 Nov 2025 21:55:43 +0100

spirv-llvm-translator-19 (19.1.12-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-18 18.1.17-1.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 11 Oct 2025 14:15:03 +0200

spirv-llvm-translator-19 (19.1.11-1) unstable; urgency=medium

  * New upstream release.
  * Merge changes from spirv-llvm-translator-18 18.1.16-1.
  * Bump spirv-headers dependency to 1.6.1+1.4.321.0-2.
  * Update .symbols control file.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 10 Sep 2025 03:19:41 +0200

spirv-llvm-translator-19 (19.1.10-2) unstable; urgency=medium



=== debian/control ===
Source: spirv-llvm-translator-22
Section: libdevel
Maintainer: Debian OpenCL team <pkg-opencl-devel@lists.alioth.debian.org>
Uploaders:
 Timo Aaltonen <tjaalton@debian.org>,
 Andreas Beckmann <anbe@debian.org>,
Build-Depends: debhelper-compat (= 13),
 dh-sequence-pkgkde-symbolshelper,
 cmake,
 gcc (>= 4:15),
 pkgconf,
 spirv-headers (>= 1.6.1+1.4.335.0),
 spirv-tools <!nocheck>,
 spirv-tools-dev,
# keep the clang/llvm version in sync, don't forget debian/tests/control
 libclang-22-dev,
 llvm-22-dev,
 clang-22 <!nocheck>,
Standards-Version: 4.7.3
Homepage: https://github.com/KhronosGroup/SPIRV-LLVM-Translator
Vcs-Browser: https://salsa.debian.org/opencl-team/spirv-llvm-translator
Vcs-Git: https://salsa.debian.org/opencl-team/spirv-llvm-translator.git -b llvm22/main

Package: libllvmspirvlib22.1
Architecture: any
Multi-Arch: same
Section: libs
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: bi-directional translator for LLVM/SPIRV -- shared library
 SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
 package includes a library and a tool for translation between LLVM IR
 and SPIR-V.
 .
 This package includes the shared library.

Package: libllvmspirvlib-22-dev
Architecture: any
Multi-Arch: same
Depends:
 libllvmspirvlib${llvm:soversion} (= ${binary:Version}),
 ${misc:Depends}
Conflicts:
 libllvmspirvlib-x.y-dev,
Breaks:
 libllvmspirvlib-dev (<< 13.0.0-3~),
Replaces:
 libllvmspirvlib-dev (<< 13.0.0-3~),
 libllvmspirvlib-x.y-dev,
Provides:
 libllvmspirvlib-x.y-dev,
Description: bi-directional translator for LLVM/SPIRV -- development files
 SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
 package includes a library and a tool for translation between LLVM IR
 and SPIR-V.
 .
 This package includes static libs and headers for development.

Package: llvm-spirv-22
Architecture: any
Depends:
 libllvmspirvlib${llvm:soversion} (= ${binary:Version}),
 ${shlibs:Depends},
 ${misc:Depends}
Description: bi-directional translator for LLVM/SPIRV
 SPIRV-LLVM-translator is a LLVM/SPIRV bi-directional translator. This
 package includes a library and a tool for translation between LLVM IR
 and SPIR-V.
 .
 This package includes the llvm-spirv-${llvm:major} binary.

=== debian/tests/control ===
Tests: upstream-testsuite
Architecture: amd64
Depends:
 @,
 cmake,
 g++,
 make,
 pkgconf,
 spirv-headers,
 spirv-tools,
 spirv-tools-dev,
 clang-22,
 llvm-22-dev,
Restrictions:
 allow-stderr,

Test-Command: debian/tests/upstream-testsuite
Features: test-name=upstream-testsuite-flaky
Architecture: !amd64 !s390x
Depends:
 @,
 cmake,
 g++,
 make,
 pkgconf,
 spirv-headers,
 spirv-tools,
 spirv-tools-dev,
 clang-22,
 llvm-22-dev,
Restrictions:
 allow-stderr,
 flaky,

Test-Command: true
Features: test-name=spirv-headers-compatibility
Depends:
 spirv-headers,
Restrictions:
 build-needed,
 allow-stderr,
 superficial,
